package com.jscape.inet.ssh.protocol.v2.messages;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.util.HexFormat;
import com.jscape.util.net.connection.MessageConnection;

import static com.jscape.util.Parameters.assertNotNull;

/**
 * @author Alex Usun
 */
public class SshMsgChannelRequestUnknown
        extends SshMsgChannelRequest<SshMsgChannelRequestUnknown.Handler> {

    public final String requestType;
    public final byte[] data;

    public SshMsgChannelRequestUnknown(int recipientChannel, String requestType, boolean wantReply, byte[] data) {
        super(recipientChannel, wantReply);

        assertNotNull(requestType);
        this.requestType = requestType;

        assertNotNull(data);
        this.data = data;
    }

    @Override
    public Class handlerClass() {
        return Handler.class;
    }

    @Override
    public void accept(Handler handler, MessageConnection<Message> connection) {
        handler.handle(this, connection);
    }

    @Override
    public String toString() {
        return "SshMsgChannelRequestUnknown {"
               + "recipientChannel=" + this.recipientChannel
               + ", requestType='" + this.requestType + '\''
               + ", wantReply=" + this.wantReply
               + ", data=" + HexFormat.formatData(this.data)
               + '}';
    }

    public interface Handler
            extends Message.HandlerBase {

        void handle(SshMsgChannelRequestUnknown message, MessageConnection<Message> connection);

    }
}
